﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MXAPI;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        const int WM_CREATE = 0x0001;
        uint uMsg=0;
        Detail detailForm = null;

        public Form1()
        {
            InitializeComponent();

            ReadDongles();
        }

        void ReadDongles()
        {
            lstDongles.Items.Clear();

            Matrix.Init_MatrixAPI();

            short cnt = Matrix.Dongle_Count(85);

            for (short dngNr = 1; dngNr <= cnt; dngNr++)
            {
                int serNr = Matrix.Dongle_ReadSerNr(1234, dngNr, 85);

                lstDongles.Items.Add(dngNr + ":" + serNr);
            }

            Matrix.Release_MatrixAPI();

        }

        private void BtnRead_Click(object sender, EventArgs e)
        {
            ReadDongles();
        }

        private void LstDongles_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if( lstDongles.SelectedIndex != -1 )
            {
                String item = (string)lstDongles.Items[lstDongles.SelectedIndex];
                String[] parts = item.Split(':');

                short dngNr = short.Parse(parts[0]);

                detailForm = new Detail(dngNr);
                detailForm.ShowDialog();
                detailForm = null;

            }
        }

        [System.Security.Permissions.PermissionSet(System.Security.Permissions.SecurityAction.Demand, Name = "FullTrust")]
        protected override void WndProc(ref Message m)
        {
            if (uMsg != 0 && m.Msg == uMsg)
            {
                if ((int)m.WParam == 0x01 || (int)m.WParam == 0x02)
                {
                    if (detailForm != null)
                        detailForm.Close();

                    ReadDongles();
                }
                return;
            }

            // Listen for operating system messages
            switch (m.Msg)
            {
                case WM_CREATE:
                    uMsg = Matrix.RegisterWindowMessage("matrixAPI4RDT");
                    break;
            }
            base.WndProc(ref m);
        }
    }
}
