/*****************************************************************************/
/*  MXAPI.CS   MS-WINDOWS Win32 (95/98/ME/NT/2K/XP)                          */
/*                                                                           */
/*  (C) TDi GmbH                                                             */
/*                                                                           */
/*  Defines to acces the Matrix API in C#                                    */
/*****************************************************************************/

namespace MXAPI
{
    using System;
    using System.Runtime.InteropServices;   /* Required namespace for the DllImport method */

	public struct DNGINFO
	{
		public short LPT_Nr;
		public short LPT_Adr;
		public short DNG_Cnt;
	};

	public class Matrix
	{
        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern uint RegisterWindowMessage(string lpString);

        /* This c#-class will import the Matrix API classes */

        [DllImport("MATRIX32RDT.DLL", EntryPoint="Init_MatrixAPI", CallingConvention = CallingConvention.StdCall)]
		public static extern short Init_MatrixAPI();

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Release_MatrixAPI", CallingConvention = CallingConvention.StdCall)]
		public static extern short Release_MatrixAPI();

		[DllImport("MATRIX32RDT.DLL", EntryPoint="GetVersionAPI", CallingConvention = CallingConvention.StdCall)]
		public static extern int GetVersionAPI();

		[DllImport("MATRIX32RDT.DLL", EntryPoint="GetVersionDRV", CallingConvention = CallingConvention.StdCall)]
		public static extern int GetVersionDRV();

		[DllImport("MATRIX32RDT.DLL", EntryPoint="GetVersionDRV_USB", CallingConvention = CallingConvention.StdCall)]
		public static extern int GetVersionDRV_USB();

		[DllImport("MATRIX32RDT.DLL", EntryPoint="GetVersionDRV_USB", CallingConvention = CallingConvention.StdCall)]
		public static extern void SetW95Access(short Mode);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="GetPortAdr", CallingConvention = CallingConvention.StdCall)]
		public static extern short GetPortAdr(short Port);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="PausePrinterActivity", CallingConvention = CallingConvention.StdCall)]
		public static extern short PausePrinterActivity();

		[DllImport("MATRIX32RDT.DLL", EntryPoint="ResumePrinterActivity", CallingConvention = CallingConvention.StdCall)]
		public static extern short ResumePrinterActivity();

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_Find", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_Find();

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_Version", CallingConvention = CallingConvention.StdCall)]
		public static extern int Dongle_Version(short DngNr, short Port);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_Model", CallingConvention = CallingConvention.StdCall)]
		public static extern int Dongle_Model(short DngNr, short Port);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_MemSize", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_MemSize(short DngNr, short Port);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_Count", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_Count(short Port);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_ReadData", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_ReadData(int UserCode, int[] Data, short Count, short DngNr, short Port);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_ReadDataEx", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_ReadDataEx(int UserCode, int[] Data, short Fpos, short Count, short DngNr, short Port);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_ReadSerNr", CallingConvention = CallingConvention.StdCall)]
		public static extern int Dongle_ReadSerNr(int UserCode, short DngNr, short Port);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_WriteData", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_WriteData(int UserCode, int[] Data, short Count, short DngNr, short Port);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_WriteDataEx", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_WriteDataEx(int UserCode, int[] Data, short Fpos, short Count, short DngNr, short Port);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_WriteKey", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_WriteKey(int UserCode, int[] KeyData, short DngNr, short Port);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_GetKeyFlag", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_GetKeyFlag(int UserCode, short DngNr, short Port);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_Exit", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_Exit();

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_EncryptData", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_EncryptData(int UserCode, int[] DataBlock, short DngNr, short Port);

		[DllImport("MATRIX32RDT.DLL", EntryPoint="Dongle_DecryptData", CallingConvention = CallingConvention.StdCall)]
		public static extern short Dongle_DecryptData(int UserCode, int[] DataBlock, short DngNr, short Port);
	}
}

